var pageParam,
    tabTag,
    pageNumber = 1,
    pageSize = 10,
    dataType = '30';
var datalist = [];
var idCard = '';
var personType = '02'
var userinfo;
var psnType = {
	'01': '失能人员',
	'02': '照护人员'
}
var faceStatus = {
	'0': '待审核',
	'1': '审核通过',
	'2': '审核不通过'
}
Base.ready(function(){
    pageParam = md.pageParam;
    dataType = pageParam.zho005;
    console.log(JSON.stringify(pageParam));
    userinfo = JSON.parse(md.getPrefs({key: 'userinfo'}));
    var fh = md.navigationBarHeight;
    $(".content-box").css("margin-bottom", fh + 'px');

    pullRefresh.setHeader(function(ret, err) {
        if(ret.state==='begin'){
            isRefesh = true; 
            console.log('下拉刷新');
            if(tabTag =="map-box"){
                pullRefresh.headerDone();
                return;
            }
            pageNumber = 1;
            pageSize = 10;
            queryCareTaskList("down");
        }else{
            console.log("end refresh.");
        }
    });

    pullRefresh.setFooter(function(ret, err){
        if(ret.state==='begin'){
            console.log('上拉加载更多');
            if(tabTag =="map-box"){
                pullRefresh.footerDone();
                return;
            }
            pageNumber += 1;
            queryCareTaskList("up");
        }else{
            console.log("end refresh.");
        }
    });
    pullRefresh.headerLoading();
});

// 搜索
$(".search-icon").on("click", function () {
  this.classList.add("no-display");
  $("#idcard").focus();
})

$("input.search-input").on("blur", function () {
  if (Base.trim(idCard) != "" ) {
    $(".search-icon").addClass("no-display");
  } else {
    $(".search-icon").removeClass("no-display");
  }
})

$("input.search-input").on("input", function () {
  idCard = this.value;
  console.log(idCard)
})
// 搜索
$(".search-btn").on("click", function () {
  var idCardTest = /^\d{17}[X]$|^\d{18}$/;
  if (Base.trim(idCard) != "" && !idCardTest.test(idCard)) {
    md.toast({msg: '请输入正确的身份证号码！'});
    return;
  }
  queryCareTaskList('down')
})

//分页查询列表
function queryCareTaskList(type){
    if (type == 'down') {
        pageNumber = 1
    }
    var params = {
        crter: userinfo.certno,
        certno: idCard,
        faceStas: '',
        facePsnType: personType
    }
    Base.requestData('listFaceRecords', params, function(ret) {
        if (ret.code == Base.REQUEST_CODE.SUCC) {
            var data = ret.data;
            datalist = data;
            datalist.forEach(function(item) {
                item.updateTime = dateFormatter(item.updtTime);
                item.psnType = psnType[item.facePsnType];
                item.status = faceStatus[item.faceStas];
            })
            if(pageNumber == 1 && data.length <= 0) {
                $(".list-item-box").empty();
                Base.noDataPage($(".content-box"),"暂无信息");
                if(type == "down"){
                    pullRefresh.headerDone();
                }else if(type == "up"){
                    pullRefresh.footerDone();
                }
                return false;
            }
            if(pageNumber > 1  && data.length <= 0) {
                Base.toast("没有更多数据啦！");
                if(type == "down"){
                    pullRefresh.headerDone();
                }else if(type == "up"){
                    pullRefresh.footerDone();
                }
                return false;
            }
            var temp = template('templist', {datalist});
            if(type == "down"){
                $(".list-item-box").html(temp);
                pullRefresh.headerDone();
            }else if(type == "up"){
                $(".list-item-box").append(temp);
                pullRefresh.footerDone();
            }
            bindClickEvent();
        } else {
            if (ret.code == Base.REQUEST_CODE.LOSE_TOKEN) {
                md.toast({msg: "您尚未登录，请先登录！"});
                Base.toLogin();
                return;
            }
            md.toast({msg: ret.message});
        }
    }, true)
}

// 人像查询
function getPersonPicture(idx) {
	var fileId = datalist[idx].ltciFileId;
	var params = {
		fileId: fileId
	}
	Base.requestData('getImageFile', params, function(ret) {
		if (ret.code != Base.REQUEST_CODE.SUCC) {
            if (ret.code == Base.REQUEST_CODE.LOSE_TOKEN) {
                md.toast({msg: "您尚未登录，请先登录！"});
                Base.toLogin();
                return;
            }
			md.toast({msg: '人像获取失败！'});
		} else {
			var url = ret.data.thumbUrl;
			showPicture(url)
		}
	}, true)
}

//服务、接单、评价操作
function bindClickEvent() {
    $(".item-box").click(function(e){
        e.stopPropagation();
        var idx = this.dataset.index;
        getPersonPicture(idx);
    });
}

// 初始化picker
var personTypePicker = new mui.PopPicker();
var type = [
    {
        value: '01',
        text: '失能人员'
    },
    {
        value: '02',
        text: '本人'
    }
];
function showPicker() {
    personTypePicker.setData(type);
    var count = 0;
    personTypePicker.show(function(items) {
        if (count >= 1) return;
        $(".personName").text(items[0].text);
        personType = items[0].value;
        queryCareTaskList('down');
    });
}

$(".selectType").on("click", function() {
    showPicker();
})

// 去详情页面
function showPicture(imgUrl) {
	$("#personImg").attr("src", imgUrl);
    $(".mark").removeClass('no-display');
}

$(".mark").on('click', function(e) {
	var _this = this;
	e.preventDefault();
	setTimeout(function() {
		_this.classList.add('no-display');
	}, 300)
})

// 过滤时间
function dateFormatter(dateStr) {
    if (!dateStr) return;
    var dateTime = new Date(dateStr);
    var y = dateTime.getFullYear();
    var m = ('0' + (dateTime.getMonth() + 1)).slice(-2);
    var d = ('0' + dateTime.getDate()).slice(-2);
    var h = ('0' + dateTime.getHours()).slice(-2);
    var mm = ('0' + dateTime.getMinutes()).slice(-2);
    var s = ('0' + dateTime.getSeconds()).slice(-2);
    return y + '/' + m + '/' + d + ' ' + h + ':' + mm + ':' + s;
}