Base.onViewOpen(function () {
  initPage();
})

var BaseUrl;
var saveUrl;
var ADZ008;
var pageData = [];
var ADZ040;
var nowTopic = 0;
var lastTopic = 0;

function initPage () {
	$("#title").html(md.pageParam.framePageData.title);
	ADZ040 = md.pageParam.framePageData.adz040;
	BaseUrl = md.pageParam.framePageData.url;
	saveUrl = md.pageParam.framePageData.save;
	ADZ008 = md.pageParam.framePageData.adz008;
	queryDataList();
}

function queryDataList () {
	var param = {
		adz040: ADZ040
	};
	Base.callBusiness(BaseUrl, param, function(res){
		if (res.data.code == -1) {
			md.toast({msg: '存在未完成课程，请学习完后再进行考试！'});
			md.closeWin();
			return;
		}
		var data = res.data;
		data.forEach( function (item, index) {
			item.actived = "";
			item.num = index + 1;
			pageData.push(item);
		})
		$(".nowIndex").html("1");
		$(".score").html(pageData.length);
		var tempStep = template("step-line", {pageData});
		$("#list_content").html(tempStep);
		var nowQues = pageData[0];
		var tempQues = template("question", nowQues);
		$("#md_content").html(tempQues);
		createEventTopic();
		createEventQues();
	}, true);
}

function createEventTopic () {
	$(".round-outer").unbind("click");
	$(".round-outer").on("click", function () {
		var idx = Number(this.dataset.index);
		if (idx > lastTopic && idx - lastTopic > 0 && !pageData[idx - 1].actived) {
			md.toast({msg: '请先完成前一题！'});
			return;
		}
		$(".round-outer").removeClass("doing");
		this.classList.add("doing");
		if (idx == pageData.length - 1) {
			$(".next-btn").html("保存");
		} else {
			$(".next-btn").html("下一题");
		}
		nowTopic = idx;
		lastTopic = idx;
		$(".nowIndex").html(nowTopic + 1);
		var nowQues = pageData[idx];
		var tempQues = template("question", nowQues);
		$("#md_content").html(tempQues);
		createEventQues();
	})
}

function createEventQues () {
	$(".btn-choose").unbind("click");
	$(".btn-choose").on("click", function () {
		var idx = this.dataset.index;
		var num = Number(this.dataset.num);
		$(".btn-choose").removeClass("actived");
		this.classList.add("actived");
		$(".topic-item_" + num).addClass("finished");
		console.log(idx)
		pageData[num - 1].actived = idx;
		console.log(JSON.stringify(pageData));
	})
}

// 上一项
$(".before-btn").on("click", function () {
	if (nowTopic == 0) {
		return;
	}
	$(".next-btn").html("下一题");
	$(".round-outer").removeClass("doing");
	$(".topic-item_" + nowTopic).addClass("doing");
	$(".topic-item_" + nowTopic).addClass("doing");
	var nowQues = pageData[nowTopic - 1];
	var tempQues = template("question", nowQues);
	$("#md_content").html(tempQues);
	createEventQues();
	nowTopic--;
	$(".nowIndex").html(nowTopic + 1);
})
// 下一项
$(".next-btn").on("click", function () {
	if (!pageData[nowTopic].actived) {
		md.toast({msg: '请先完成前一题！'});
		return;
	}
	if (nowTopic == pageData.length - 1) {
		$(".next-btn").html("保存");
		saveExam();
		return;
	} else if (nowTopic == pageData.length - 2) {
		$(".next-btn").html("保存");
	} else {
		$(".next-btn").html("下一题");
	}
	$(".round-outer").removeClass("doing");
	$(".topic-item_" + (nowTopic + 2)).addClass("doing");
	var nowQues = pageData[nowTopic + 1];
	var tempQues = template("question", nowQues);
	$("#md_content").html(tempQues);
	createEventQues();
	nowTopic++;
	$(".nowIndex").html(nowTopic + 1);
})

// 保存
$(".savaData").on("click", function () {
	saveExam();
})

function saveExam () {
	var valid =  pageData.some(function (item) {
		return item.actived == "";
	})
	if (valid) {
		md.toast({msg: '请完成所有题目后保存'});
		return;
	}
	var user = Base.strToJson(md.getPrefs({key: 'userinfo'}));
	var answer = [];
	pageData.forEach( function (item) {
		answer.push({
			adz010: item.adz010,
			adz004: item.actived
		})
	})
	var param = {
		adz040: ADZ040,
		answer: answer,
		userid: user.userid,
		aac002: user.aac002,
		aac003: user.aac003,
		adz008: ADZ008
	}
	Base.callBusiness(saveUrl, param, function(res){
		if(res.code == 1){
			md.toast({msg: '答案保存成功！'});
			md.sendEvent({
			    name: 'reflesh'
			});
            md.closeWin();
		}else{
			Base.toast(res.msg,'2000','middle');
		}
	}, true);
}