(function($){

    /*
    *    Object参数说明：
    *    参数            类型       必填     默认值             说明
    *    idCardNum      String      是       ""      设置身份证号 
    *    videoDuration  int         否       10      设置视频时长（范围为5~30，默认10，单位：秒） 
    *    videoQuality   int         否       2       设置视频质量，默认为HLVideoQualityMedium 
    *    cameraType     int         否       2       设置前后置摄像头，默认为HLCameraTypeBack 
    */
    $.HLVideoCapture = function(aac002){
        mdHLVideoCapture.startCapture({
            idCardNum: aac002,
            videoDuration: 8,
            videoQuality: 3,
            cameraType: 2
        }, function(ret, err) {
        /*
            *  ret参数说明：
            *       数值                      说明
            *   resultCode                  见下表 
            *   idNum                       身份证号 
            *   videoFilePath               视频文件完整路径 
            *   publicKeyAlias              HLParameter类参数 
            *   encryptedPasswdByPublicKey  HLParameter类参数
            *   encryptedInputMsg           HLParameter类参数
            *   AESCipherAlgorithm          HLParameter类参数
            *
            * resultCode参数说明：
            *    数值          说明
            *    1    SUCCEED    找到对应人员的信息 
            *    2    OPEN_CAMERA_FAILED    打开摄像头失败 
            *    3    EXIT    退出 
        */
            console.log(JSON.stringify(ret));
            var code = ret.resultCode;
            if(code == '1'){
                fuRequestCZX070(ret);
            }else if(code == '2'){
                Base.toast("打开摄像头失败");
            }else if(code == '3'){
                /*Base.toast("退出");*/
            }else{
                Base.toast("发生异常，请稍后再试!");
            }
        });
    }


    /*请求人像对比接口*/
    function fuRequestCZX070(param){
        md.showProgress({
            content: '视频识别中(约30s)...请耐心等待结果',
            modal: false
        });
        param.systemType = md.systemType;
        Base.callBusiness("czx070",param,function(data){
            console.log("data:"+Base.jsonToStr(data));
            if(data.code == '1'){
                //识别成功
                submitRespBack(data.data,param.videoFilePath);
            }else{
                Base.toast(data.msg);
            }
            md.hideProgress(); 
        });
    }

    //删除文件根据绝对地址
    $.removeSavePic = function(filePath){
        console.log("删除文件时绝对地址："+filePath);
        fileMgr.remove({
            path:filePath
        },function(ret,err){})
    }
})($)