/*
/----------------------start-----------------------/
	数据库操作封装--带有数据源的DB
/-----------------------end---------------------/
*/

	var DBUtil={
		DBname:"care.db",//数据库名称
		DBPath:"fs://database/care.db",//数据库的fs路径
		dirPath:"fs://database",//数库的fs文件夹
		DBoldPath:"wgt://care.db",//数据库wgt地址
		version:"0.2.6",//当前数据库版本
		/**
			判断数据库是否存在
			@param:DBPath[string]--数据库文件路径
			@return: true/false[Boolean]--返回成功（true）或失败（false）
		*/
		existDB:function(callback){
			var flag=false;
			fileMgr.exist({
					    path: this.DBPath
					},callback);
			
		},
		/**
			创建datebase文件夹
			@param:dirPath[string]--需要创建的文件路径
			@return: true/false[Boolean]--返回成功（true）或失败（false）
		*/
		createDir:	function (callback){
			fileMgr.createDir({
					    path: this.dirPath
					}, callback);
		},
		/**
			copy数据库文件
			@param:DBoldPath[string]--copy源文件地址
			@param:DBnewPath[string]--copy目标文件地址
			@return: true/false[Boolean]--返回成功（true）或失败（false）
		*/
		copyDB:	function (callback){
			fileMgr.copy({
			    oldPath: this.DBoldPath,
			    newPath: this.DBPath
			},callback);

		},

		/**
			数据库打开成功
			@param:DBname[string]--数据库名称
			@param:DBpath[string]--数据库文件路径
			@return: true/false[Boolean]--返回成功（true）或失败（false）
		*/
		openData:function (callback){
			var	defalutFunc=function(ret, err){
					    if(ret.status){
					       console.log("数据库打开成功");
					    }else{
					       console.log("openDatabase:"+JSON.stringify( err ));
					    }
					}
					console.log("执行打开数据库的语句");
				md.openDatabase({
					    name: this.DBname,
					    path: this.dirPath
					}, callback||defalutFunc);

				
		},
		/**
			根据executeSql进行表查询
			@param:DBname[string]--执行的sql语句的数据库名称
			@param:querySql[string]--执行的sql语句
			@return: data[JSON]--查询出的数据
		*/
		queryCodeBySQL:function (querySql,callback){
				console.log(querySql);
				md.selectSql({
				    name: this.DBname,
				    path:this.dirPath,
				    sql: querySql
				},callback);
		},

		/**
			根据executeSql进行表查询 callback回调
			@param:DBname[string]--执行的sql语句的数据库名称
			@param:querySql[string]--执行的sql语句
			@return: data[JSON]--查询出的数据
		*/
		queryCodeByTag:function (aaa100,callback){ 
			var querySql = "select AAA100 as aaa100,AAA101 as aaa101,AAA102 as aaa102,AAA103 as aaa103,AAA104 as aaa104,YAB003 as yab003,AAE120 as aae120 from zhaa10 where AAA100='"+aaa100+"' order by AAA104";
				console.log(querySql);
				md.selectSql({
				    name: this.DBname,
				    path:this.dirPath,
				    sql: querySql
				},callback);
		},
		/**
			根据executeSql进行表查询 retuen 返回
			@param:DBname[string]--执行的sql语句的数据库名称
			@param:querySql[string]--执行的sql语句
			@return: data[JSON]--查询出的数据
		*/
		queryCodeByTagRet:function (aaa100){
			var querySql = "select AAA100 as aaa100,AAA101 as aaa101,AAA102 as aaa102,AAA103 as aaa103,AAA104 as aaa104,YAB003 as yab003,AAE120 as aae120 from zhaa10 where AAA100='"+aaa100+"' order by AAA104";
				console.log(querySql);
				md.selectSql({
				    name: this.DBname,
				    path:this.dirPath,
				    sql: querySql
				},function(ret, err){
					if(ret)return ret.data;					
				});
		},

		/**	执行sql语句//建表之类的语句
			@param:executeSql[string]--执行的sql语句
			@param:DBname[string]--执行的sql语句的数据库名称
		*/
		executeSQL:function (executeSql,callback){
			md.executeSql({
			    name: this.DBname,
			    path:this.dirPath,
			    sql: executeSql   
			},callback);
		},

		/**
			关闭数据库
			@param:executeSql[string]--执行的sql语句
			@return: true/false[Boolean]--返回成功（true）或失败（false）
		*/

		closeDatabase:function (){
	     	md.closeDatabase({
			    name:this.DBname
			}, function(ret, err){
			    if(ret.status){
			       console.log("关闭数据库完成");
			    }else{
			        console.log(JSON.stringify( err ));
			    }
			});
		},
		/**
			查询评估表数据
		*/
		queryTableCode:function(table,callback){
			
			var querySql = "select ZHE001 AS  zhe001,ZHE002  AS zhe002,ZHE003  AS zhe003,ZHE004  AS zhe004,ZHE005 AS  zhe005,ZHE006  AS zhe006,ZHE007  AS zhe007, ZHE008 AS  zhe008, ZHE009  AS zhe009,ZHE010  AS zhe010, ZHE011 AS  zhe011, AAE100 from zhe01 where AAE100 = '1' AND ZHE010 = '"+table+"' order by zhe002,zhe006"
			console.log(querySql);
				md.selectSql({
				    name: this.DBname,
				    path:this.dirPath,
				    sql: querySql
				},function(ret, err){
					    if(ret){
					       //组装数据
					       var data_prarms=[];
					       var data = ret.data;
					       var item={};
					       //组装父节点
					       var len = data.length;
					       for (var i = 0; i < len; i++) {
					       	var fatherData={}; 
					       		item=data[i];
					       		if(item.zhe002=="0"){
					       			//父级条目
					       			fatherData["id"]=item.zhe001;
					       			fatherData["name"]=item.zhe004;
					       			fatherData["desc"]=item.zhe009;
					       			fatherData["items"]=[];
					       			data_prarms.push(fatherData);

					       		}
					       		
					       }
					       //组装父节点里的数据
					        for (var i = 0; i < len; i++) {
					       		item=data[i];
					       		if(item.zhe002=="0"){
					       			//父级条目
					       			continue;
					       		}
					       		for (var key in data_prarms) {
					       			if(data_prarms[key].id == item.zhe002){
					       				data_prarms[key].items.push(item);
					       			}
					       		}
					       }					      
					       callback(data_prarms);
					    }else{
					       callback();
					       console.log("查询错误:"+JSON.stringify( err ));
					    }
					});
		}, 
		/**
		查询评定等级根据abc表对应的值
		*/
		queryRanking :function(obj,callback){
			var A=obj.a||"";
			var B=obj.b||"";
			var C=obj.c||"";
			var querySql = "select ZHA001 as zha001,ZHA002 as zha002,ZHA003 as zha003,ZHA004 as zha004,ZHA005 as zha005,ZHA006 as zha006,ZHA007 as zha007 from zhe100 where ZHA003 = '"+A+"' and ZHA004 = '"+B+"' and ZHA005 = '"+C+"' order by zha006 desc  limit 0,1";
			console.log(querySql);
				md.selectSql({
				    name: this.DBname,
				    path:this.dirPath,
				    sql: querySql
				},function(ret, err){
					if(ret){
						callback(ret.data);
						console.log("data:"+JSON.stringify( ret ));
					}else{
						callback();
						console.log("查询错误:"+JSON.stringify( err ));
					}
				});
		},
		/**
			查询ADAS表中的父节点
		*/
		queryADAS :function(callback){
			var querySql = "select ZHE001 AS  zhe001,ZHE002  AS zhe002,ZHE003  AS zhe003,ZHE004  AS zhe004,ZHE005 AS  zhe005,ZHE006  AS zhe006,ZHE007  AS zhe007, ZHE008 AS  zhe008, ZHE009  AS zhe009, ZHE011 AS  zhe011 ,ZHE013 AS  zhe013 from zhe02 where zhe003='1' and AAE100 = '1' order by zhe013";
			console.log(querySql);
				md.selectSql({
				    name: this.DBname,
				    path:this.dirPath,
				    sql: querySql
				},function(ret, err){
					if(ret){
						callback(ret.data);
						//console.log("data:"+JSON.stringify( ret ));
						console.log("length:"+ret.data.length);
						
					}else{
						callback();
						console.log("查询错误:"+JSON.stringify( err ));
					}
				});
		},
		/**
			查询ADAS表中的子节点
		*/
		queryADASSub :function(callback){
			var querySql = "select ZHE001 AS  zhe001,ZHE002  AS zhe002,ZHE003  AS zhe003,ZHE004  AS zhe004,ZHE005 AS  zhe005,ZHE006  AS zhe006,ZHE007  AS zhe007, ZHE008 AS  zhe008, ZHE009  AS zhe009, ZHE011 AS  zhe011 ,ZHE013 AS  zhe013 from zhe02 where zhe003='2' and AAE100 = '1' order by zhe002,zhe006";
			console.log(querySql);
				md.selectSql({
				    name: this.DBname,
				    path:this.dirPath,
				    sql: querySql
				},function(ret, err){
					if(ret){
						callback(ret.data);
						//console.log("data:"+JSON.stringify( ret ));
						console.log("length:"+ret.data.length);
					}else{
						callback();
						console.log("查询错误:"+JSON.stringify( err ));
					}
				});
		},

		/**
			根据码值获取对应的中文值
		*/
		queryValueByCode :function(Code,value){
			var querySql = "select AAA100 as aaa100,AAA101 as aaa101 from zhaa10 where AAA100='"+Code+"' and aaa102 = '"+value+"'";
			console.log(querySql);
				md.selectSql({
				    name: this.DBname,
				    path:this.dirPath,
				    sql: querySql
				},function(ret, err){
					if(ret){
						return ret.data;
					}else{
						return "";
					}
				});
		},

	

		/**
			数据库版本检查
			@param:executeSql[string]--执行的sql语句
			@return: true/false[Boolean]--返回成功（true）或失败（false）
		*/
		checkVersion:function(){

			DBUtil.openData(function(ret, err){
					    if(ret.status){
					       console.log("数据库打开成功");

					       var sql='select version from version';
			DBUtil.queryCodeBySQL(sql,function( ret, err ){ 
					if(ret){	
							//关闭数据库删除文件
							DBUtil.closeDatabase();					
							console.log("版本查询执行成功");
						//判断版本
						var DbVersion=ret.data[0].version;
						var AppDBversion=DBUtil.version;
						console.log("数据库版本ide："+AppDBversion);
						console.log("数据库版本db："+DbVersion);
						if(DbVersion!=AppDBversion){
							console.log("更新数据库");
							//数据库版本与最新版本不一致，删除数据库文件
							fileMgr.remove({
							    path: DBUtil.DBPath
							}, function(ret, err){      
							    if( ret.status ){
							       //删除文件成功，copy文件
							        DBUtil.copyDB(
								         	function(ret, err){      
											    if( ret.status ){
											  		console.log("copy成功");

											    }else{
											    	console.log("copyDB:"+JSON.stringify( err ) );
											    }
											});

							    }else{
							    	console.log(JSON.stringify( err ));
							    }
							});
						}else{
							console.log("已是最新数据库");
							
						}

				    }else{
				    	 $.toast({
						      msg:JSON.stringify( err ),
						});
						console.log("执行失败");
					}

			});

					    }else{
					       console.log("openDatabase:"+JSON.stringify( err ));
					    }
					});
			
		},

		/**
			初始化带有数据源的数据
		*/
		initDB:function(){
			DBUtil.existDB(
				function(ret,err){
					    if( ret.exist ){
					    	//存在文件
				          console.log("-----存在数据库文件");
				         DBUtil.checkVersion();
					    }else{
				       		console.log("existDB:"+JSON.stringify( err ) );
				       		DBUtil.createDir(
				       			function(ret, err){     
								    if( ret.status ){
								         console.log("-----创建datebase文件夹");
								         //创建成功copy文件
								         DBUtil.copyDB(
								         	function(ret, err){      
											    if( ret.status ){
											  		console.log("copy成功");
											  		DBUtil.openData();
											    }else{
											    	console.log("copyDB:"+JSON.stringify( err ) );
											    }
											});
								    }else{
								        console.log("createDir:"+JSON.stringify( err ) );
								    }
								}
				       			);
					    }
					});
		},

	}
		
	
		
	
		
		



					
