(function($) {
	if (typeof Base == "undefined") {
		Base = {};
		window.Base = Base;
	}
	$.extend(Base, {
		// "ctxPath": "/cdsim/",
		// "serverPath" : "http://192.168.43.62:8093/engine/rest/",   // 本地
		// "serverPath" : "http://192.168.3.10:8093/engine/rest/",   // 本地
		// "serverPath" : "http://42.123.92.185:8093/engine/rest/",  // 测试服务器
		"serverPath" : "http://42.123.92.185:9000/engine/rest/",   //正式服务器
		"staticsPath": "statics/",
		"serverType": "callBusiness"
	});

	// 请求返回状态值
	Base.REQUEST_CODE = {
		SUCC: '0',
		FAIL: '-1',
		LOSE_TOKEN: '403'
	}

	// 接口地址
	Base.requestServerUrlPath = {
		"login": "loginService/login", // 登录
		"selectNursePlan": "nursePlanService/selectNursePlan", // 完成照护任务选项列表
		"recordUpload": "nurseOrderService/recordUpload", // 确认完成照护
		"imcompleteOrder": "nursePlanService/imcompleteOrder", // 未完成服务列表
		"selectMonthPlan": "nursePlanService/selectMonthPlan", // 查询失能人员列表
		"selectNurseOrder": "nurseOrderService/selectNurseOrder", // 查询服务统计
		"completeOrder": "nursePlanService/completeOrder", // 查询历史服务记录
		"uploadTemplate": "faceRecordApiService/uploadTemplate", // 模板采集
		"listFaceRecords": "faceRecordApiService/listFaceRecords", // 查询采集记录
		"getImageFile": "commonApiService/getImageFile", // 查询人像
		"updateOrderFace": "faceRecordApiService/updateOrderFace", // 保存识别通过标识
		"getPublicDList":"othermanageService/getPublicDList",//查询通知公告列表
		"getPublicDById":"othermanageService/getPublicDById",//查询通知公告详情
		"selectDisaInUscc": "nursePlanService/selectDisaInUscc", // 查询机构下所有失能人员
		"getImgCaptcha": "loginService/getImgCaptcha", // 获取验证码
		"uploadImageFile": "commonApiService/uploadImageFile", // 上传图片文件
		"matchFace": "faceRecordApiService/matchFace", // 机构工作人员人脸识别接口
		"getFaceInfo": "faceRecordApiService/getFaceInfo", // 失能人员人脸识别接口
	}
	Base.callBusinessUrlPath = {
		"login": "L01001", // 登录
		"selectNursePlan": "C01002", // 完成照护任务选项列表
		"recordUpload": "C01003", // 确认完成照护
		"imcompleteOrder": "C01004", // 未完成服务列表
		"selectMonthPlan": "C01005", // 查询失能人员列表
		"selectNurseOrder": "C01006", // 查询服务统计
		"completeOrder": "C01007", // 查询历史服务记录
		"uploadTemplate": "C01008", // 模板采集
		"listFaceRecords": "C01009", // 查询采集记录
		"getImageFile": "C01010", // 查询人像
		"updateOrderFace": "C01011", // 保存识别通过标识
		"getPublicDList": "C01012",//查询通知公告列表
		"getPublicDById": "C01013",//查询通知公告详情
		"selectDisaInUscc": "C01014", // 查询机构下所有失能人员
		"uploadImageFile": "C01015", // 上传图片文件
		"matchFace": "C01016", // 机构工作人员人脸识别接口
		"getFaceInfo": "C01017", // 失能人员人脸识别接口
		"getImgCaptcha": "L01004",// 获取图片验证码
		"editPassword": "L01006", // 修改密码
		"addCpltD" : "C01019"  // 投诉建议
	}
	Base.requestData = function(urlType, param, callback, mask, type, nopage) {
		var requestType = Base.serverType;
		if (requestType == 'callBusiness') {
			Base.callBusiness(urlType, param, callback, mask, type, nopage);
		} else if (requestType == 'requestServer') {
			Base.requestServer(urlType, param, callback, mask, type, nopage);
		}
	}
	Base.RLSB_config = {
		'nmservice': {name:'nmservice', url: '192.168.3.23:9090'},
		'hlfaceapi': {name:'hlfaceapi', url: '223.93.147.251:49090'}
	}
	Base.RLSB = {
		name: Base.RLSB_config.hlfaceapi.name,
		url: Base.RLSB_config.hlfaceapi.url,
		time: 5,
		threshold: 80,
		isRoundMask: true
	}
	/* 调用人脸识别是否通过的状态保存记录
	*@param {Object}
	*            params 参数
	*/
	Base.faceRecordUpdate = function(params, callback) {
		var userinfo = JSON.parse(md.getPrefs({key: 'userinfo'}))
		var _params = {
			opterId: userinfo.psnNo,
			opterName: userinfo.psnName,
			orderFaceType: params.orderFaceType || '',
			nurseOrderId: params.nurseOrderId || '',
		    /*护理人员开始人脸识别标志*/
		    nurseFaceFlagStart: params.nurseFaceFlagStart || '',
		    /*护理人员结束人脸识别标志*/
		    nurseFaceFlagEnd: params.nurseFaceFlagEnd || '',
		    /*护理人员开始服务地址经度*/
		    nurseLongitudeStart: params.nurseLongitudeStart || '',
		    /*护理人员结束服务地址经度*/
		    nurseLongitudeEnd: params.nurseLongitudeEnd || '',
		    /*护理人员开始服务地址纬度*/
		    nurseLatitudeStart: params.nurseLatitudeStart || '',
		    /*护理人员结束服务地址纬度*/
		    nurseLatitudeEnd: params.nurseLatitudeEnd || '',
		    /**护理人员开始服务定位地址*/
		    nurseGpsStart: params.nurseGpsStart || '',
		    /*护理人员结束服务定位地址*/
		    nurseGpsEnd: params.nurseGpsEnd || '',
		   /*失能人员人脸识别标志*/
		    disaFaceFlag: params.disaFaceFlag || '',
		    /*失能人员地址经度*/
		    disaLongitude: params.disaLongitude || '',
		    /*失能人员地址纬度*/
		    disaLatitude: params.disaLatitude || '',
		    /*失能人员地址*/
		    disaAddr: params.disaAddr || ''
	    }
	    Base.requestData('updateOrderFace', _params, function(res) {
	    	console.log(JSON.stringify(res))
	    	callback(res)
	    	if (res.code == 0) {

	    	}
	    }, false)
	}

	/**
	 * 请求服务
	 * 
	 * @method requestServer
	 * @param {String}
	 *            urlType 根据类型取得服务器地址 必选
	 * @param {String}
	 *            data 请求参数对象 必选可为null，
	 * @param {String}
	 *            callback 回调方法 可选
	 * @param {Boolean}
	 *            mask 是否显示蒙层 可选 默认false
	 * @param {String}
	 *            type 请求方式:post,get 可选 默认post
	 */
	Base.requestServer = function(urlType, param, callback, mask, type, nopage) {
		urlType = Base.trim(urlType);
		var isLogin = nopage || '';
		var url = "";
		if (urlType.indexOf("http://") != -1) {
			url = urlType;
		} else {
			url = Base.serverPath + Base.requestServerUrlPath[urlType];
		}
		param = param || {};
		console.log("asddsdada" + isLogin)

		if (isLogin != 'loginpage') {
			var storage = md.getPrefs({key: 'userinfo'}) || null;
			param.nursePsnType = storage ? JSON.parse(storage).nursePsnType : '';
		}
		
		type = type || "POST";
		var apiToken = Base.getStorage("apiTokenCG");
		if (!apiToken) {
			apiToken = ""
		}
		param.apiToken = apiToken;
		
		param = JSON.stringify(param).replace(/\"/g,"'");
		if (mask) {
			Base.showGifMask();
		}
		console.log(url + "---" + type + "----" + param);
		var ajax = $.ajax({
			type : type,
			contentType : "application/json; charset=utf-8", // post提交乱码
			url : url,
			data : param,
			crossDomain: true,
			success : function(data) {
				Base.removeGifMask();
				// alert("***" + data);
				if (typeof data == "string") {
					data = eval("(" + data + ")");
				}
				callback(data);
			},
			error : function(xhr, type) {
				Base.removeGifMask();
				md.toast({msg: "网络错误"});
			}
		});
		return ajax;
	}


	Base.callBusiness = function(urlType, param, callback, mask, type, nopage) {
		urlType = Base.trim(urlType);
		var isLogin = nopage || '';
		var url = "";
		if (urlType.indexOf("http://") != -1) {
			url = urlType;
		} else {
			url = Base.serverPath + Base.callBusinessUrlPath[urlType];
		}
		param = param || {};

		if (isLogin != 'loginpage') {
			var storage = md.getPrefs({key: 'userinfo'}) || null;
			param.nursePsnType = storage ? JSON.parse(storage).nursePsnType : '';
		}
		
		type = type || "post";
		var access_token = Base.getStorage("access_token");
		if (access_token == undefined) {
			access_token = "";
		}
		var apiToken = Base.getStorage("apiTokenCG");
		if (!apiToken) {
			apiToken = ""
		}
		param.apiToken = apiToken;
		
		if (mask) {
			Base.showGifMask();
		}
		timestamp = new Date().getTime();
		var params = {};
		params.access_token = access_token;
		params.access_key = "care_app";
        params.version = "1.0.0";
        params.timestamp = timestamp;
        params.biz_content = JSON.stringify(param).replace(/\"/g,"'");
		md.ajax({
            method: type,
            url: url,
            data: {
                values: params
            }
        }, function(ret, err) {
            console.log(urlType + '请求结果：' + JSON.stringify(ret))
            Base.removeGifMask();
            if (ret && ret.body.biz_data) {
            	callback(ret.body.biz_data)
            } else {
            	// token失效处理
            	if (ret.body && ret.body.code == '-105') {
            		Base.getAccessToken(function(ret) {
            			md.setPrefs({
			                key: 'access_token',
			                value: ret.body.access_token
			            });
			            md.setPrefs({
			                key: 'refresh_token',
			                value: ret.body.refresh_token
			            });
            			Base.callBusiness(urlType, param, callback, mask, type, nopage)
            		})
            	} else {
            		md.toast({
	            	    msg: '请求失败！',
	            	    duration: 2000,
	            	    location: 'middle'
	            	});
            	}
            }
        })
	}
// 3.22 b057262d99ff88c7debe5b77f401eb866a9fbde6064d5b2b09b74fcdbfdaeaed
// loc  18a3b92bccebfb0f13647299a2107342ac6ef0df0b75ee1a6b35ce53ecd945b0
// zs 60a3f210eefe36e1ee82db47dcb3e85d938616bb8a4be757944d732b72540f48
// cs 0a12132a2f6336b751a02a021bda6b525b7330811442a55d5e41ca29708f77af
	Base.getAccessToken = function(callback) {
		timestamp = new Date().getTime();
		var key = '60a3f210eefe36e1ee82db47dcb3e85d938616bb8a4be757944d732b72540f48';
		var keyToken = '';
		Base.showGifMask();
		rsaEncrypt.encrypt({value: key}, function(ret,err){
		    if (ret) {
		        //inputString的value加密成功
		        keyToken = ret.value
		        md.ajax({
		            method: 'post',
		            url: Base.serverPath + 'request_token', // 192.168.21.115
		            data: {
		                values: {
		                	access_key: "care_app",
		                	timestamp: timestamp,
		                	request_token: keyToken
		                }
		            }
		        }, function(ret, err) {
		        	console.log("token获取成功：" + JSON.stringify(ret));
		        	console.log("token获取失败：" + JSON.stringify(err))
		        	callback(ret)
		        });
		    } else {
		    	Base.removeGifMask();
		    	md.toast({
		    	    msg: '登录失败，未获取到令牌，请重新登录！',
		    	    duration: 2000,
		    	    location: 'middle'
		    	});
		    }
		});
	}

	Base.getRefreshToken = function(callback) {
		timestamp = new Date().getTime();
		md.ajax({
            method: 'post',
            url: Base.serverPath + 'refresh_token',
            data: {
                values: {
                	access_key: "care_app",
                	timestamp: timestamp,
                	refresh_token: md.getPrefs({key: 'refresh_token'})
                }
            }
        }, function(ret, err) {
            console.log("token过期重新获取：" + JSON.stringify(ret))
            var token = ret.body.access_token
            md.setPrefs({
                key: 'access_token',
                value: token
            });
            callback();
        });
	}

	// 杭州海量活体检测
	Base.HLFace = function (title, callback) {
		var userinfo = JSON.parse(md.getPrefs({key: 'userinfo'}));
		console.log("-------"+JSON.stringify(userinfo))
		var HLActions = {
			actions: [].concat(userinfo.hlActions.split(',')),
			actionNumber: userinfo.hlActionNumber
		}
		mdHLFace.startLivenessDetect({
            isOpenBackCamera: false,
            safetyLevel: 2,
            actions: HLActions.actions,
            actionNumber: HLActions.actionNumber,
            actionTime: 10,
            isShowGuide: true,
            isShowNoticeWhenDetectionSlowing: true,
            noticeWhenDetectionSlowing:'性能不佳',
            totalThemeColor:'#28A69F',
            title: title
        }, function(ret, err){
            switch (ret.code) {
            	case 0:
            		if (ret.detectionString == 'Ig==00000000000000000000') {
            			callback(null, '活体动作验证失败！');
            		} else {
            			callback(ret.detectionString);
            		}
            		break;
            	case -1:
            		callback(null, '您取消了活体检测');
            		break;
            	case -2:
            		callback(null, '相机打开失败，请重试！');
            		break;
            	default: break;
            }      
        });
	}

	Base.ucm = {
		'sysid':"chxtest",
		'addrcode':"510100",
		'loginid':"developer",
		'busitype':"IMAGE",
		"url":'http://192.168.17.190:9001/cloudstore/ucm/ucmAction!postFile.do'
	}
	//SDK返回值标准设置
	Base.SDK_Success=1;
	Base.SDK_Error=-1;
	//服务器请求返回
	Base.FW_Success=1;//请求服务成功
	Base.FW_Error=-1;//请求服务失败
	Base.FW_TiemOut=-2;//登录会话超时，重新登录
	/**
	 * 点击事件
	 * 
	 * @method click
	 * @param {string}
	 *            selector 必选 选择器
	 * @param {string}
	 *            act 可选 点击效果class: md-act1(背景色为#eee)、md-act2(点击缩小弹动效果)
	 * @param {function}
	 *            func 必须 回调方法， 接收两个参数1：点击当前元素$(this), 2: 点击事件状态e
	 */
	Base.click = function(selector, func, act) {
		var hasTouch = ('ontouchstart' in window);
		var className = act || "";
		if (className) {
			if (hasTouch) {
				$(document).on("touchstart", selector, function() {
					$(this).addClass(className);
				});
				$(document).on("touchend", selector, function() {
					$(this).removeClass(className);
				});
				$(document).on("touchcancel", selector, function() {
					$(this).removeClass(className);
				});
				$(document).on("touchmove", selector, function() {
					$(this).removeClass(className);
				});
			} else {
				$(document).on("mousedown", selector, function() {
					$(this).addClass(className);
				});
				$(document).on("mouseup", selector, function() {
					$(this).removeClass(className);
				});
			}
		}
		var eventName = "click";
		if(typeof mdui != "undefined" && "ontouchstart" in window) {
			eventName = "touchstart";
		}
		$(document).on(eventName, selector, function(e) {
			var $this = $(this);
			func($this, e);
		});
	}
	
	/**
	 * 信息提示()
	 * 
	 * @method toast
	 * @param {string}
	 *            msg 必选 提示信息
	 * @param {string}
	 *            time 可选 持续时长，单位：毫秒
	 * @param {string}
	 *            location 可选 弹出位置，顶部、中间或底部（top-顶部/middle-中间/bottom-底部
	 */
	Base.toast = function(msg, time, location) {
		var msgs = msg||"提示";
		var time = time||2000;
		var location = location||"middle";
		md.toast({
		    msg:msgs,
		    duration: time,
		    location: location
		});
	}

	/**
	 * 显示gifMask
	 * 
	 * @method showGifMask
	 */
	Base.showGifMask = function(text) {
    		md.showProgress({
		        content: text,
		        modal: true
		    });
	}
	/**
	 * 移除gifMask（与showGifMask相对应）
	 * 
	 * @method removeGifMask
	 */
	 Base.removeGifMask = function() {
	    	md.hideProgress();
	}
	/**
	 * 消息提示（轻）
	 * 
	 * @method msgTip
	 * @param {String}
	 *            msg 必选 提示内容
	 * @param {time:
	 *            持续时间, top: top, left: left, bottom: bottom, right: right} 可选
	 */
	Base.msgTip = function(msg, param) {
		if (arguments.length == 1) {
			param = {};
		}
		var _t = param["time"] || 2000;
		var style = "style='";
		var _top = param["top"];
		if (_top) {
			style += "top:" + _top + ";";
		}
		var _bottom = param["bottom"];
		if (_bottom) {
			style += "bottom:" + _bottom + ";";
		}
		var _left = param["left"];
		if (_left) {
			style += "left:" + _left + ";";
		}
		var _right = param["right"];
		if (_right) {
			style += "right:" + _right + ";";
		}
		style += "'";
		var $div = $("<div class=\"md-msgtip\" " + style
				+ "><div class='mm-msg'>" + msg + "</div></div>");
		$("body").append($div);
		setTimeout(function() {
			$div.remove();
		}, _t);
	}
	/**
	 * 创建上拉下拉刷新
	 * 
	 * @param {int}
	 *            type 0/不传： 上拉下拉刷新； 1：下拉刷新；2：上拉刷新
	 * @param {function}
	 *            down： 上拉回调方法
	 * @param {function}
	 *            up： 下拉回调方法
	 */
	Base.creatRefresh = function(type, down, up) {
		if (down == undefined) {
			down = function() {
				setTimeout(function() {
					Base.removeDown();
				}, 1000);
			};
		}
		if (up == undefined) {
			up = function() {
				setTimeout(function() {
					Base.removeUp();
				}, 1000);
			};
		}
		var top = $(".md-header").height()|| $(".search-header").height() || 0;
		var paddingBottom = $(".md-footer").height() || 0;
		var d1 = ('<div id="pullrefresh" class="mdui-content mdui-scroll-wrapper" style="top: '
				+ top + 'px; padding-bottom: ' + paddingBottom + 'px;">' + '<div class="mdui-scroll"></div></div>');
		var min_height = $(window).height() - top - paddingBottom;
		$(".md-content").css("min-height", min_height+"px").wrap(d1);
		if (typeof mdui == "undefined") {
			Base.msgTip("未定义mdui");
			return false;
		}
		var pr = {
			pullRefresh : {
				container : '#pullrefresh',
			}
		}
		if (type == 1) {
			pr.pullRefresh.down = {
				callback : down
			}
		} else if (type == 2) {
			pr.pullRefresh.up = {
				contentrefresh : '正在加载...',
				callback : up
			}
		} else {
			pr.pullRefresh.down = {
				callback : down
			}
			pr.pullRefresh.up = {
				contentrefresh : '正在加载...',
				callback : up
			}
		}
		mdui.init(pr);
	}
	Base.removeDown = function() {
		mdui('#pullrefresh').pullRefresh().endPulldownToRefresh();
	}
	Base.removeUp = function() {
		mdui('#pullrefresh').pullRefresh().endPullupToRefresh();
	}
	// 获得参数
	Base.getParams = function() {
		var data = {};
		if (Base.isPC() === true) {
			var href = decodeURI(decodeURI(window.location.search.substring(1)));
			var arr = href.split("&");
			for (var i = 0; i < arr.length; i++) {
				var d = arr[i].split("=");
				data[d[0]] = d[1];
			}
		} else {
			var data = md.pageParam;
		}
		return data;
	}
	// 刷新页面
	Base.refreshWin = function() {
		window.location.reload();
	}
	/**
	 * 没有网络显示显示
	 */
	Base.noNetworkPage = function(selector) {
		var $n = $(selector);
		if (!$n[0]) {
			$n = $(".md-content");
		}
		var div = '' + '<div class="md-box md-ac md-pc md-ver md-f1">'
				+ '<div class="md-box no-img md-img"></div>'
				+ '<div class="md-box no-text1">网络错误找不到页面~~</div>'
				+ '<div class="md-box no-text2">点击屏幕重新尝试</div>' + '</div';
	};
	/**
	 * 没有数据显示显示
	 */
	Base.noDataPage = function(selector, text) {
		var $n = $(selector);
		if (!$n[0]) {
			$n = $(".md-content");
		}
		if (text == undefined) {
			text = "无相关数据";
		}
		var div = '' + '<div class="md-box nodata_content md-ver md-ac md-pc">'
				+ '<div class="md-box nodata"></div>'
				+ '<div class="md-box nodata_text">' + text + '</div>' + '</div>';
		$n.html(div);
	};

	Base.isLogin=function(){
		var token = md.getPrefs({key: 'userid'});
		if(token){
			return true;
		}
		return false;
	};
	/**
     * 打开window
     */
    Base.openWin = function(data){
    	 var slidBackEnabledType=true;
    	 if(!data.slidBackEnabled){
    	 	slidBackEnabledType = data.slidBackEnabled;
    	 }
        md.openWin({
            name: data.name, //window名字，不能为空字符串
            url: data.url, //页面地址
            animation :data.animation, //（可选项）动画参数，不传时使用默认动画（从右往左推入）
            reload: data.reload, //是否重新加载页面
            slidBackEnabled:slidBackEnabledType,//是否支持滑动返回
            pageParam: {
                isRelavte : data.isRelavte, //相对布局方式
                frameName: data.frameName || "",
                frameUrl: data.frameUrl || "",
                title: data.title || "",
                bounces: data.bounces || false, //（可选项）页面是否弹动
                bgColor: data.bgColor,
                reload: data.reload, //是否重新加载页面
                framePageData: data.framePageData
            } //（可选项）页面参数，新页面中可以通过md.pageParam获取
        });
    } 
    /*
	绑定返回事件	
	*/
	$(document).on("click", ".back-icon", function() {
	           md.closeWin();      
	    });
	/*下拉刷新的自定义封装*/
	Base.setHeader = function(callback){
		pullRefresh.setHeader(function(ret, err) {
			if(ret.state == 'begin'){
				START = 0;
				LIMITE = 8;
				queryData("down");
				isRefrash = true;
			}
		});
	}

	Base.confirm = function (params, callback) {
		dialog.alert({
	        title: params.title || '提示',
	        msg: params.msg,
	        buttons: params.btns || ['确定', '取消']
	    },function(ret){
	        callback(ret.buttonIndex);
	    })
	}

	Base.toLogin = function(tag){
        md.openFrame({
		    name: 'login',
		    url: 'wgt://care/login/login.html',
		    rect: {
		        y: 0
		    },
		    bounces:false
		});
	}
}($));